summaryrefslogtreecommitdiffstats
path: root/contrib
diff options
context:
space:
mode:
authorDan McGee <dan@archlinux.org>2008-02-02 21:09:22 +0100
committerDan McGee <dan@archlinux.org>2008-02-02 21:12:34 +0100
commit4fad7855fae4a01b265c7d28c12b995a19ebc72d (patch)
treecf4802d0d1bfa36f05d0506a001017e004505585 /contrib
parentc492ca840c54d8d45d5916a280f2119c363e0aba (diff)
downloadpacman-4fad7855fae4a01b265c7d28c12b995a19ebc72d.tar.gz
pacman-4fad7855fae4a01b265c7d28c12b995a19ebc72d.tar.xz
Remove gensync and updatesync from normal distribution
Move these two scripts into contrib/, and start the process of de-automaking them by removing the @sysconfdir@ references and the gettext initialization. The removal of all gettext will soon follow. Signed-off-by: Dan McGee <dan@archlinux.org>
Diffstat (limited to 'contrib')
-rw-r--r--contrib/.gitignore0
-rw-r--r--contrib/Makefile.am2
-rw-r--r--contrib/README4
-rwxr-xr-xcontrib/gensync150
-rwxr-xr-xcontrib/updatesync153
5 files changed, 309 insertions, 0 deletions
diff --git a/contrib/.gitignore b/contrib/.gitignore
deleted file mode 100644
index e69de29b..00000000
--- a/contrib/.gitignore
+++ /dev/null
diff --git a/contrib/Makefile.am b/contrib/Makefile.am
index 9f01e187..7654848f 100644
--- a/contrib/Makefile.am
+++ b/contrib/Makefile.am
@@ -1,9 +1,11 @@
EXTRA_DIST = \
PKGBUILD.vim \
bash_completion \
+ gensync \
pacdiff \
pacsearch \
re-pacman \
+ updatesync \
vimproject \
wget-xdelta.sh \
zsh_completion \
diff --git a/contrib/README b/contrib/README
index c9ff86f4..0edeaf7d 100644
--- a/contrib/README
+++ b/contrib/README
@@ -25,3 +25,7 @@ may need to be updated).
wget-xdelta.sh - A download script for pacman which allows binary deltas
generated with makepkg to be used instead of downloading full binary packages.
This should cut download sizes for some package upgrades significantly.
+
+gensync, updatesync - The former repository management scripts that have since
+been superseded by repo-add and repo-remove. They are here for posterity's
+sake, and to show how repo-add and repo-remove can be wrapped in other scripts.
diff --git a/contrib/gensync b/contrib/gensync
new file mode 100755
index 00000000..829ae3c2
--- /dev/null
+++ b/contrib/gensync
@@ -0,0 +1,150 @@
+#!/bin/bash
+#
+# gensync
+#
+# Copyright (c) 2002-2007 by Judd Vinet <jvinet@zeroflux.org>
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+#
+
+myver='3.1.1'
+
+# functions
+
+usage() {
+ printf "gensync (pacman) %s\n\n" "$myver"
+ printf "$(gettext "Usage: %s <root> <destfile> [package_directory]")\n\n" "$0"
+ printf "$(gettext "\
+gensync will generate a sync database by reading all PKGBUILD files\n\
+from <root>. gensync builds the database in a temporary directory\n\
+and then compresses it to <destfile>.\n\n")"
+ printf "$(gettext "\
+gensync will calculate md5sums of packages in the same directory as\n\
+<destfile>, unless an alternate [package_directory] is specified.\n\n")"
+ printf "$(gettext "\
+note: The <destfile> name is important. It must be of the form\n\
+ {treename}.db.tar.gz where {treename} is the name of the custom\n\
+ package repository you configured in /etc/pacman.conf. The\n\
+ generated database must reside in the same directory as your\n\
+ custom packages (also configured in /etc/pacman.conf)\n\n")"
+ echo "$(gettext "Example: gensync /var/abs/local /home/mypkgs/custom.db.tar.gz")"
+}
+
+version() {
+ printf "gensync (pacman) %s\n" "$myver"
+ printf "$(gettext "\
+Copyright (C) 2002-2007 Judd Vinet <jvinet@zeroflux.org>.\n\n\
+This is free software; see the source for copying conditions.\n\
+There is NO WARRANTY, to the extent permitted by law.\n")"
+}
+
+error () {
+ local mesg=$1; shift
+ printf "==> ERROR: ${mesg}\n" "$@" >&2
+}
+
+die () {
+ error $*
+ exit 1
+}
+
+check_force () {
+ local i
+ for i in ${options[@]}; do
+ local lc=$(echo $i | tr [:upper:] [:lower:])
+ if [ "$lc" = "force" ]; then
+ true
+ fi
+ done
+ false
+}
+
+# PROGRAM START
+
+if [ "$1" = "-h" -o "$1" = "--help" ]; then
+ usage
+ exit 0
+fi
+
+if [ "$1" = "-V" -o "$1" = "--version" ]; then
+ version
+ exit 0
+fi
+
+if [ $# -lt 2 ]; then
+ usage
+ exit 1
+fi
+
+# source system and user makepkg.conf
+if [ -r /etc/makepkg.conf ]; then
+ source /etc/makepkg.conf
+else
+ die "/etc/makepkg.conf not found. Cannot continue."
+fi
+
+if [ -r ~/.makepkg.conf ]; then
+ source ~/.makepkg.conf
+fi
+
+
+d=$(dirname $1)
+rootdir="$(cd $d && pwd)/$(basename $1)"
+d="$(dirname $2)"
+destdir="$(cd $d && pwd)"
+destfile="$destdir/$(basename $2)"
+pkgdir=""
+if [ "$3" != "" ]; then
+ pkgdir="$3"
+fi
+
+[ ! -d "$rootdir" ] && die "$(gettext "invalid root dir: %s")" $rootdir
+
+echo "$(gettext "gensync: building database entries, generating md5sums...")" >&2
+cd "$destdir"
+
+pkgs=""
+forcepkgs=""
+
+for file in $(find "$rootdir"/* -name "$BUILDSCRIPT"); do
+ unset pkgname pkgver pkgrel options
+
+ source $file || die "$(gettext "failed to parse %s")" $file
+ if [ "$arch" = 'any' ]; then
+ CARCH='any'
+ fi
+ if [ "$pkgdir" != "" ]; then
+ pkgfile="$pkgdir/$pkgname-$pkgver-$pkgrel-${CARCH}${PKGEXT}"
+ else
+ pkgfile="$destdir/$pkgname-$pkgver-$pkgrel-${CARCH}${PKGEXT}"
+ fi
+
+ if [ ! -f "$pkgfile" ]; then
+ error "$(gettext "could not find %s-%s-%s-%s%s - skipping")" $pkgname $pkgver $pkgrel $CARCH $PKGEXT
+ else
+ if check_force; then
+ forcepkgs="$forcepkgs $pkgfile"
+ else
+ pkgs="$pkgs $pkgfile"
+ fi
+ fi
+done
+
+echo "$(gettext "creating repo DB...")"
+
+# we'll trim the output just a tad, as gensync may be used on large repos
+repo-add $destfile $pkgs --force $force_pkgs \
+ | grep -e "package" -e "database"
+
+# vim: set ts=2 sw=2 noet:
diff --git a/contrib/updatesync b/contrib/updatesync
new file mode 100755
index 00000000..4df02ef9
--- /dev/null
+++ b/contrib/updatesync
@@ -0,0 +1,153 @@
+#!/bin/bash
+#
+# updatesync
+#
+# Copyright (c) 2004 by Jason Chu <jason@archlinux.org>
+# Derived from gensync (c) 2002-2006 Judd Vinet <jvinet@zeroflux.org>
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+#
+
+myver='3.1.1'
+
+# functions
+
+usage() {
+ printf "updatesync (pacman) %s\n\n" "$myver"
+ printf "$(gettext "Usage: %s <action> <destfile> <option> [package_directory]")\n\n" "$0"
+ printf "$(gettext "\
+updatesync will update a sync database by reading a PKGBUILD and\n\
+modifying the destfile. updatesync updates the database in a temporary\n\
+directory and then compresses it to <destfile>.\n\n")"
+ printf "$(gettext "There are two types of actions:\n\n")"
+ printf "$(gettext "upd - Will update a package's entry or create it if it doesn't exist.\n It takes the package's PKGBUILD as an option.\n")"
+ printf "$(gettext "del - Will remove a package's entry from the db. It takes the package's\n name as an option.\n")"
+ echo
+ printf "$(gettext "\
+updatesync will calculate md5sums of packages in the same directory as\n\
+<destfile>, unless an alternate [package_directory] is specified.\n\n")"
+ echo "$(gettext "Example: updatesync upd /home/mypkgs/custom.db.tar.gz PKGBUILD")"
+}
+
+version() {
+ printf "updatesync (pacman) %s\n" "$myver"
+ printf "$(gettext "\
+Copyright (C) 2004 Jason Chu <jason@archlinux.org>.\n\n\
+This is free software; see the source for copying conditions.\n\
+There is NO WARRANTY, to the extent permitted by law.\n")"
+}
+
+error () {
+ local mesg=$1; shift
+ printf "==> ERROR: ${mesg}\n" "$@" >&2
+}
+
+die () {
+ error $*
+ exit 1
+}
+
+check_force () {
+ local i
+ for i in ${options[@]}; do
+ local lc=$(echo $i | tr [:upper:] [:lower:])
+ if [ "$lc" = "force" ]; then
+ true
+ fi
+ done
+ false
+}
+
+# PROGRAM START
+
+if [ "$1" = "-h" -o "$1" = "--help" ]; then
+ usage
+ exit 0
+fi
+
+if [ "$1" = "-V" -o "$1" = "--version" ]; then
+ version
+ exit 0
+fi
+
+if [ $# -lt 3 ]; then
+ usage
+ exit 1
+fi
+
+# source system and user makepkg.conf
+if [ -r /etc/makepkg.conf ]; then
+ source /etc/makepkg.conf
+else
+ die "/etc/makepkg.conf not found. Cannot continue."
+fi
+
+if [ -r ~/.makepkg.conf ]; then
+ source ~/.makepkg.conf
+fi
+
+if [ "$1" != "upd" -a "$1" != "del" ]; then
+ usage
+ exit 1
+fi
+
+action=$1
+pkgdb=$2
+option=$3
+pkgdir="$(pwd)"
+if [ "$4" != "" ]; then
+ pkgdir="$4"
+fi
+opt_force=""
+
+if [ "$action" = "upd" ]; then # INSERT / UPDATE
+ if [ ! -f "$option" ]; then
+ die "$(gettext "%s not found")" $option
+ fi
+
+ unset pkgname pkgver pkgrel options
+
+ source $option || die "$(gettext "failed to parse %s")" $option
+ if [ "$arch" = 'any' ]; then
+ CARCH='any'
+ fi
+ pkgfile="$pkgdir/$pkgname-$pkgver-$pkgrel-${CARCH}${PKGEXT}"
+
+ if [ ! -f "$pkgfile" ]; then
+ die "$(gettext "could not find %s-%s-%s-%s%s - aborting")" $pkgname $pkgver $pkgrel $CARCH $PKGEXT
+ fi
+
+ if check_force; then
+ opt_force="--force"
+ fi
+
+ repo-add "$pkgdb" $opt_force "$pkgfile"
+else # DELETE
+ fname="$(basename $option)"
+ if [ "$fname" = "PKGBUILD" ]; then
+ if [ ! -f "$option" ]; then
+ die "$(gettext "%s not found")" $option
+ fi
+
+ unset pkgname pkgver pkgrel options
+ source $option
+ else
+ pkgname=$option
+ fi
+
+ repo-remove "$pkgdb" "$pkgname"
+fi
+
+exit 0
+# vim: set ts=2 sw=2 noet: